import DaReManager 0.1 as DRM
import "../account_group" as AG
import "./" as SELF

DRM.FormCard {
    short_name: "Account"
    full_name: "Account"

    reload_block: SELF.DBTable{state: "select_record"}

    content: [
        DRM.FormStringSentence {caption.value:"ID";value.field:"id"; enabled.value:false }

        , DRM.FormReferenceSentence {
            caption.value:"Group"; value.field:"group_id";

            select_block: AG.FormRegistry{
                registry.search_on: true;

                confirm_visible: true;
                confirm_shortname: 'Select';

                output_fields_on: true;
                output_fields:[DRM.ReplaceField{source_code:'id'; code: 'group_id' }]
            }

            value_description.field:'group_name'

            value.reload_block: AG.DBTable {
                input_fields_on: true;
                input_fields: [DRM.ReplaceField{code: 'group_id'}]

                state: "sql"
                sql: "SELECT name AS group_name FROM account_group WHERE id=:group_id"
            }

        }

        , DRM.FormBoolSentence {
            caption.value:"State";
            value.field:"income_expense";

            value_description_checked:"Income"
            value_description_unchecked:"Expense"
        }
        , DRM.FormStringSentence {caption.value:"Name";value.field:"name"; }
        , DRM.FormStringSentence {caption.value:"Measure";value.field:"measure"; }
    ]



    confirm_visible: true;
    confirm_block: SELF.DBTable{state: "update"}
}
