import DaReManager 0.1 as DRM

import "./" as SELF

DRM.FormRegistry {
    short_name: "Accounts"
    full_name: "Accounts"

    registry.columns:[
        DRM.FormRegistryColumn {code:'group_name'; short_name: 'Group'}
        , DRM.FormRegistryColumn {code:'income_expense'; short_name: 'State'}
        , DRM.FormRegistryColumn {code:'name'; short_name: 'Name'}
        , DRM.FormRegistryColumn {code:'measure'; short_name: 'Measure'}
        , DRM.FormRegistryColumn {code:'id'; short_name: 'ID'}
    ]

    registry.reload_block:SELF.DBTable{
        input_fields_on: true;

        state: 'sql'

        sql: "SELECT acc.id
                    , gr.name AS group_name
                    , CASE acc.income_expense WHEN 'true' THEN 'Income' ELSE 'Expense' END AS income_expense
                    , acc.name
                    , acc.measure
                FROM account AS acc
                LEFT JOIN account_group AS gr ON gr.id=acc.group_id";
    }

    registry.add_block: SELF.FormCard{
        short_name: "Adding Account"
        full_name: "Do you really want to add Account?"

        confirm_block: SELF.DBTable{state: "insert"}
    }

    registry.open_block: SELF.FormCard{}

    registry.delete_block: SELF.FormCard{
        short_name: "Deleting Account"
        full_name: "Do you really want to delete Account?"

        confirm_block: SELF.DBTable{state: "delete"}
        confirm_shortname: "Delete"

    }

}
