import DaReManager 0.1 as DRM

import "./" as SELF

DRM.FormRegistry {
    short_name: "Incomes and Expenses"
    full_name: "Incomes and Expenses"

    header: DRM.FormParagraph{
        content:[
            DRM.FormDateSentence{enabled.visible: true; enabled.field: "is_date_from";  caption.value:"Date from"; value.field:"date_from"}
            , DRM.FormDateSentence{enabled.visible: true; enabled.value: false; enabled.field: "is_date_to"; caption.value:"to"; value.field:"date_to"}
        ]
    }
    registry.columns:[
        DRM.FormRegistryColumn {code:'date'; short_name: 'Date'}
        , DRM.FormRegistryColumn {code:'group_name'; short_name: 'Group'}
        , DRM.FormRegistryColumn {code:'account_name'; short_name: 'Аccount'}
        , DRM.FormRegistryColumn {code:'income_expense'; short_name: 'Income/Expense'}
        , DRM.FormRegistryColumn {code:'description'; short_name: 'Description'}
        , DRM.FormRegistryColumn {code:'count'; short_name: 'Count'}
        , DRM.FormRegistryColumn {code:'account_measure'; short_name: 'Measure'}
        , DRM.FormRegistryColumn {code:'income_sum'; short_name: 'Incoming Sum'; agg_caption: "Total incoming Sum"; agg_function: "sum"}
        , DRM.FormRegistryColumn {code:'expense_sum'; short_name: 'Expenses Sum'; agg_caption: "Total expenses Sum"; agg_function: "sum"}
        , DRM.FormRegistryColumn {code:'id'; short_name: 'ID'}
    ]

    registry.reload_block:SELF.DBTable{
        input_fields_on: true; input_fields:[DRM.ReplaceField{code:"is_date_from"},DRM.ReplaceField{code:"date_from"}, DRM.ReplaceField{code:"is_date_to"}, DRM.ReplaceField{code:"date_to"}]
        state: 'sql'
        sql: "SELECT ie.id
                , ie.date
                , gr.name AS group_name
                , acc.name AS account_name
                , CASE acc.income_expense WHEN 'true' THEN 'Income' ELSE 'Expense' END AS income_expense
                , ie.description
                , CASE acc.measure WHEN '' THEN NULL ELSE ie.count END AS count
                , acc.measure AS account_measure
                , CASE acc.income_expense WHEN 'true' THEN ie.sum ELSE null END AS income_sum
                , CASE acc.income_expense WHEN 'true' THEN null ELSE ie.sum END AS expense_sum
                , balance.sum AS balance_sum
            FROM income_expense AS ie
            LEFT JOIN account AS acc ON acc.id=ie.account_id
            LEFT JOIN account_group AS gr ON gr.id=acc.group_id
            LEFT JOIN (SELECT sum(CASE acc.income_expense WHEN 'true' THEN ie.sum ELSE -ie.sum END) AS sum
                        FROM income_expense AS ie
                        LEFT JOIN account AS acc ON acc.id=ie.account_id
                        ) AS balance ON 1=1
            WHERE ((:is_date_from='false' OR :date_from<=ie.date) AND (:is_date_to='false' OR ie.date<=:date_to))";
    }

    registry.add_block: SELF.FormCard{
        short_name: "Adding Income or Expense"
        full_name: "Do you really want to add Income or Expense?"

        reload_block:SELF.DBTable{
            input_fields_on: true
            state: "sql"
            sql: "SELECT date() AS date, 0 as account_group_id, 0 as account_id, 0 as price, 0 as count, 0 as sum"
        }

        confirm_block: SELF.DBTable{state: "insert"}
        confirm_shortname: "Add"

    }

    registry.open_block: SELF.FormCard{}

    registry.delete_block: SELF.FormCard{
        short_name: "Deleting Income or Expense"
        full_name: "Do you really want to delete Incomes and Expenses?"

        confirm_block: SELF.DBTable{state: "delete"}
        confirm_shortname: "Delete"

    }

}
