/********************   License  English   *************************************
 *    Library: Data Registry Manager
 *    File: DrmBlockDBPostgreSQL.cpp
 *    last change: Sergey Gershkovich, 2012/8/16
 *
 *
 *    Copyright (c) 2012, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ********************   License Russian, UTF-8  ********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmBlockDBPostgreSQL.cpp
 *
 *    Copyright (c) 2012, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */

#include <QtSql/QSqlDatabase>

#include <QtDebug>
#include <QSqlError>
#include <QtSql/QSqlQuery>


#include "DrmBlockDBPostgreSQL.h"
#include "../sys/DrmSysSQLDataBases.h"

static QString SelectFieldsSQL="SELECT pg_attribute.attname as name, not index_attribute.attname is null AS ispindex"
        " FROM pg_attribute "
        " INNER JOIN pg_class ON pg_attribute.attrelid=pg_class.oid"
        " INNER JOIN pg_namespace ON pg_namespace.oid=pg_class.relnamespace"
        " LEFT JOIN pg_index ON pg_index.indrelid=pg_class.oid AND pg_index.indisprimary"
        " LEFT JOIN pg_attribute AS index_attribute ON index_attribute.attrelid=pg_index.indexrelid AND index_attribute.attname=pg_attribute.attname"
        ;

DrmBlockDBPostgreSQL::DrmBlockDBPostgreSQL()
    :DrmSysBlock()
{
    setCode("DrmBlockPOsgreSQL");

    State="sql";
    SQL = "";

    OutPutDataSetContainer.setLink(&DataSet);
}

DrmBlockDBPostgreSQL::~DrmBlockDBPostgreSQL()
{
    // TODO Auto-generated destructor stub
}

void
DrmBlockDBPostgreSQL::run(DrmSysDataSet *InPutDataSet)
{
    QString result="";
    if (State=="connect" ) result=exeCONNECT(InPutDataSet);
    else  if (State=="sql") result=exeSQL(InPutDataSet);
    else  if (State=="select_record") result=exeSELECT_RECORD(InPutDataSet);
    else  if (State=="insert") result=exeINSERT(InPutDataSet);
    else  if (State=="update") result=exeUPDATE(InPutDataSet);
    else  if (State=="delete") result=exeDELETE(InPutDataSet);
    else result="No state for DrmBlockDBPostgreSQL: "+State;

    if (result!="") {qDebug()<<result; terminated(result); }

    finish();

}

QString
DrmBlockDBPostgreSQL::exeCONNECT(DrmSysDataSet *)
{
    QSqlDatabase db;

    db = DrmSysSQLDataBases_addDataBase("QPSQL",Connection.getCode());
    db.setHostName(Connection.getHostName());
    db.setDatabaseName(Connection.getDatabaseName()) ;
    db.setUserName(Connection.getUserName()) ;
    db.setPassword(Connection.getPassword()) ;

    if (!db.open()) return db.lastError().text();

    return "";
}

QString
DrmBlockDBPostgreSQL::exeSELECT_RECORD(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QPSQL",Connection.getCode()));
    sql=SelectFieldsSQL+ " WHERE pg_namespace.nspname='"+Schema.trimmed()+"' AND pg_class.relname='"+Table.trimmed()+"'";
    SqlQuery.prepare(sql);
    if (!SqlQuery.exec()) return "Error " + SqlQuery.lastError().text() + " in SQL: " + sql;

    QSqlQueryModel Fields;
    Fields.setQuery(SqlQuery);

    sql="SELECT FROM \""+Schema.trimmed()+"\".\""+Table.trimmed()+"\"";

    QString sql_select="";
    QString sql_where="";

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+Fields.data(Fields.index( i, 0)).toString().trimmed();
            }

            if (!sql_select.isEmpty()) sql_select+=", ";
            sql_select+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"";
        }
    }

    if (sql_select.isEmpty() || sql_where.isEmpty()) return "No input VALUES for "+sql;

    sql="SELECT "+sql_select+" FROM \""+Schema.trimmed()+"\".\""+Table.trimmed()+"\""" WHERE "+sql_where;
    SqlQuery.prepare(sql);

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
            {
                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()!=QVariant::String) || (value.toString()!=""))
                    SqlQuery.bindValue(":"+fieldname.trimmed(), value);
            }
    }

    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";
}

QString
DrmBlockDBPostgreSQL::exeINSERT(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QPSQL",Connection.getCode()));
    sql=SelectFieldsSQL+ " WHERE pg_namespace.nspname='"+Schema.trimmed()+"' AND pg_class.relname='"+Table.trimmed()+"'";
    SqlQuery.prepare(sql);
    if (!SqlQuery.exec()) return "Error " + SqlQuery.lastError().text() + " in SQL: " + sql;

    QSqlQueryModel Fields;
    Fields.setQuery(SqlQuery);

    sql="INSERT INTO \""+Schema.trimmed()+"\".\""+Table.trimmed()+"\"";

    QString sql_fields="";
    QString sql_values="";
    QString sql_returning="";

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
            {
                if (!sql_returning.isEmpty()) sql_returning+=", ";
                sql_returning+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"";

            } else {
                if (!sql_fields.isEmpty()) sql_fields+=", ";
                if (!sql_values.isEmpty()) sql_values+=", ";

                sql_fields+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_values+="''";
                else sql_values+=":"+Fields.data(Fields.index( i, 0)).toString().trimmed();
           }
        else {}
    }

    if (sql_fields.isEmpty() || sql_values.isEmpty()) return "No input VALUES for "+sql;

    sql+=" ("+sql_fields+") VALUES ("+sql_values+") RETURNING "+sql_returning;
    SqlQuery.prepare(sql);

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (!Fields.data(Fields.index( i, 1)).toBool() // not primary index field in database
            && DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            if ((value.type()!=QVariant::String) || (value.toString()!=""))
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);
        }
    }


    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";

}


QString
DrmBlockDBPostgreSQL::exeUPDATE(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QPSQL",Connection.getCode()));
    sql=SelectFieldsSQL+ " WHERE pg_namespace.nspname='"+Schema.trimmed()+"' AND pg_class.relname='"+Table.trimmed()+"'";
    SqlQuery.prepare(sql);
    if (!SqlQuery.exec()) return "Error " + SqlQuery.lastError().text() + " in SQL: " + sql;

    QSqlQueryModel Fields;
    Fields.setQuery(SqlQuery);

    sql="UPDATE \""+Schema.trimmed()+"\".\""+Table.trimmed()+"\"";

    QString sql_set="";
    QString sql_where="";
    QString sql_returning="";

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+Fields.data(Fields.index( i, 0)).toString().trimmed();


                if (!sql_returning.isEmpty()) sql_returning+=", ";
                sql_returning+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"";

            } else {
                if (!sql_set.isEmpty()) sql_set+=", ";

                sql_set+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_set+="''";
                else  sql_set+=":"+Fields.data(Fields.index( i, 0)).toString().trimmed();
            }
        else {}

    }

    if (sql_set.isEmpty() || sql_where.isEmpty()) return "No input VALUES for "+sql;

    sql+=" SET "+sql_set+" WHERE "+sql_where+" RETURNING "+sql_returning;
    SqlQuery.prepare(sql);

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            if ((value.type()!=QVariant::String) || (value.toString()!=""))
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);
        }
    }


    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";
}

QString

DrmBlockDBPostgreSQL::exeDELETE(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QPSQL",Connection.getCode()));
    sql=SelectFieldsSQL+ " WHERE pg_namespace.nspname='"+Schema.trimmed()+"' AND pg_class.relname='"+Table.trimmed()+"'";
    SqlQuery.prepare(sql);
    if (!SqlQuery.exec()) return "Error " + SqlQuery.lastError().text() + " in SQL: " + sql;

    QSqlQueryModel Fields;
    Fields.setQuery(SqlQuery);

    sql="DELETE FROM \""+Schema.trimmed()+"\".\""+Table.trimmed()+"\"";

    QString sql_where="";
    QString sql_returning="";

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+="\""+Fields.data(Fields.index( i, 0)).toString().trimmed()+"\"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+Fields.data(Fields.index( i, 0)).toString().trimmed();
            }
    }

    if ( sql_where.isEmpty()) return "No input VALUES for WHERE in "+sql;

    sql+=" WHERE "+sql_where;
    SqlQuery.prepare(sql);

    for (int i=0; i<Fields.rowCount(); ++i)
    {
        QString fieldname=Fields.data(Fields.index( i, 0)).toString();
        if(Fields.data(Fields.index( i, 1)).toBool()) //  primary index field in database
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            if ((value.type()!=QVariant::String) || (value.toString()!=""))
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);
        }
    }


    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";
}

QString
DrmBlockDBPostgreSQL::exeSQL(DrmSysDataSet *InPutDataSet)
{
    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QPSQL",Connection.getCode()));

    if (SQL!="")
    {
        SqlQuery.prepare(SQL);

        for (int column=0; column < InPutDataSet->columnCount(); ++column)
        {
            QString fieldname = InPutDataSet->headerData(column, Qt::Horizontal).toString();
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            SqlQuery.bindValue(":"+fieldname.trimmed(), value);

            //qDebug()<<fieldname<<" =  "<<value.toString();

        }
        //qDebug()<<"SQL=             "<<SQL;

        if (!SqlQuery.exec()) return "Error " + SqlQuery.lastError().text() + " in SQL: " + SQL;
    }

    DataSet.setQuery(SqlQuery);
    return "";

}

