/********************   License  English   *************************************
 *    Library: Data Registry Manager
 *    File: DrmBlockDBPostgreSQL.h
 *    last change: Sergey Gershkovich, 2012/8/16
 *
 *
 *    Copyright (c) 2012, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ********************   License Russian, UTF-8  ********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmBlockDBPostgreSQL.h
 *
 *    Copyright (c) 2012, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */

#ifndef DRMBLOCKDBPOSTGRESQL_H
#define DRMBLOCKDBPOSTGRESQL_H

#include <QtSql/QSqlQueryModel>
#include <QDeclarativeListProperty>


#include "../sys/DrmSysBlock.h"

class DrmBlockDBPostgreSQLCONNECT: public DrmSysObject
{
    Q_OBJECT
    Q_PROPERTY(DrmSysBlock* property_block READ getPropertyBlock WRITE setPropertyBlock)

    Q_PROPERTY(QString hostname READ getHostName WRITE setHostName)
    Q_PROPERTY(QString databasename READ getDatabaseName WRITE setDatabaseName)
    Q_PROPERTY(QString username READ getUserName WRITE setUserName)
    Q_PROPERTY(QString password READ getPassword WRITE setPassword)

public:
    DrmSysBlock* getPropertyBlock(){return PropertyBlockPrivate;}
    void setPropertyBlock(DrmSysBlock* PropertyBlock){PropertyBlockPrivate=PropertyBlock;}

    QString getHostName(){return HostNamePrivate;}
    void setHostName(QString HostName){HostNamePrivate=HostName;}

    QString getDatabaseName(){return DatabaseNamePrivate;}
    void setDatabaseName(QString DatabaseName){DatabaseNamePrivate=DatabaseName;}

    QString getUserName(){return UserNamePrivate;}
    void setUserName(QString UserName){UserNamePrivate=UserName;}

    QString getPassword(){return PasswordPrivate;}
    void setPassword(QString Password){PasswordPrivate=Password;}

    DrmBlockDBPostgreSQLCONNECT(){}

private:

    DrmSysBlock* PropertyBlockPrivate;

    QString HostNamePrivate;
    QString DatabaseNamePrivate;
    QString UserNamePrivate;
    QString PasswordPrivate;
};


class DrmBlockDBPostgreSQL: public DrmSysBlock

{
    Q_OBJECT

    Q_PROPERTY(QString state READ getState WRITE setState)
    Q_PROPERTY(DrmBlockDBPostgreSQLCONNECT* connection READ getConnection)
    Q_PROPERTY(QString schema READ getSchema WRITE setSchema)
    Q_PROPERTY(QString table READ getTable WRITE setTable)
    Q_PROPERTY(QString sql READ getSQL WRITE setSQL)


public:
    DrmBlockDBPostgreSQL();
    virtual ~DrmBlockDBPostgreSQL();

    QString getState(){return State;}
    void setState(QString State) {this->State=State;}

    DrmBlockDBPostgreSQLCONNECT* getConnection(){return &Connection;}

    QString getSchema(){return Schema;}
    void setSchema(QString Schema) {this->Schema=Schema;}

    QString getTable(){return Table;}
    void setTable(QString Table) {this->Table=Table;}

    QString getSQL(){return SQL;}
    void setSQL(QString SQL) {this->SQL=SQL;}


    virtual void run(DrmSysDataSet* InPutDataSet);

protected:
    QString exeCONNECT(DrmSysDataSet *InPutDataSet);
    QString exeSELECT_RECORD(DrmSysDataSet *InPutDataSet);
    QString exeINSERT(DrmSysDataSet *InPutDataSet);
    QString exeUPDATE(DrmSysDataSet *InPutDataSet);
    QString exeDELETE(DrmSysDataSet *InPutDataSet);
    QString exeSQL(DrmSysDataSet *InPutDataSet);

private:
    QString State;

    DrmBlockDBPostgreSQLCONNECT Connection;
    QString Schema;
    QString Table;
    QString SQL;

    QSqlQueryModel DataSet;

};

#endif // DRMBLOCKDBPOSTGRESQL_H
