/********************   License  English   *************************************
 *    Library: Data Registry Manager
 *    File: DrmBlockDBSQLite.cpp
 *    last change: Sergey Gershkovich, 2012/7/3
 *
 *
 *    Copyright (c) 2012, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ********************   License Russian, UTF-8  ********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmBlockDBSQLite.cpp
 *
 *    Copyright (c) 2012, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */

#include <QtSql/QSqlDatabase>

#include <QtDebug>
#include <QSqlError>
#include <QtSql/QSqlQuery>

#include "DrmBlockDBSQLite.h"
#include "../sys/DrmSysSQLDataBases.h"



DrmBlockDBSQLite::DrmBlockDBSQLite()
    :DrmSysBlock()
{
    setCode("DrmBlockDBSQLite");

    State="sql";
    SQL = "";

    OutPutDataSetContainer.setLink(&DataSet);
}

DrmBlockDBSQLite::~DrmBlockDBSQLite()
{
    // TODO Auto-generated destructor stub
}

void
DrmBlockDBSQLite::run(DrmSysDataSet *InPutDataSet)
{
    QString result="";
    if (State=="connect" ) result=exeCONNECT(InPutDataSet);
    else  if (State=="sql") result=exeSQL(InPutDataSet);
    else  if (State=="select_record") result=exeSELECT_RECORD(InPutDataSet);
    else  if (State=="insert") result=exeINSERT(InPutDataSet);
    else  if (State=="update") result=exeUPDATE(InPutDataSet);
    else  if (State=="delete") result=exeDELETE(InPutDataSet);
    else result="No state for DrmBlockDBPostgreSQL: "+State;

    if (result!="") {qDebug()<<result; terminated(result); }

    finish();

}

bool
DrmBlockDBSQLite::loadTableFields()
{
    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));
    SqlQuery.prepare("PRAGMA table_info('"+Table+"');");

    if (!SqlQuery.exec()) return false;

    TableFields.setQuery(SqlQuery);
    return true;
}

QString
DrmBlockDBSQLite::TableFieldName(int RecNo)
{
    return DrmSysDataSet_getFieldValue(&TableFields,"name",QVariant(),RecNo).toString();
}

bool
DrmBlockDBSQLite::TableField_isPrimaryIndex(int RecNo)
{
    return DrmSysDataSet_getFieldValue(&TableFields,"pk",QVariant(),RecNo).toBool();
}


QString
DrmBlockDBSQLite::exeCONNECT(DrmSysDataSet *)
{
    QSqlDatabase db;

    db = DrmSysSQLDataBases_addDataBase("QSQLITE",getCode());
    db.setDatabaseName(DataBasePath) ;

    if (!db.open()) return db.lastError().text();

    return "";
}

QString
DrmBlockDBSQLite::exeSELECT_RECORD(DrmSysDataSet *InPutDataSet)
{
    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));

    if (!loadTableFields()) return "Can't load '" +Table.trimmed()+ "' table info";

    QString sql_select="";
    QString sql_where="";

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            if(TableField_isPrimaryIndex(i)) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+=fieldname.trimmed()+"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+fieldname.trimmed();
            }

            if (!sql_select.isEmpty()) sql_select+=", ";
            sql_select+=fieldname.trimmed();
        }
    }

    if (sql_select.isEmpty() || sql_where.isEmpty()) return "No input VALUES for "+sql_select;

    QString sql="SELECT "+sql_select+" FROM "+Table.trimmed()+" WHERE "+sql_where;
    SqlQuery.prepare(sql);

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            if(TableField_isPrimaryIndex(i)) //  primary index field in database
            {
                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()!=QVariant::String) || (value.toString()!=""))
                    SqlQuery.bindValue(":"+fieldname.trimmed(), value);
            }
        }
    }

    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";
}

QString
DrmBlockDBSQLite::exeINSERT(DrmSysDataSet *InPutDataSet)
{
    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));

    if (!loadTableFields()) return "Can't load '" +Table.trimmed()+ "' table info";

    QString sql="INSERT INTO "+Table.trimmed();

    QString sql_fields="";
    QString sql_values="";
    QString sql_pi="";

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if (TableField_isPrimaryIndex(i)){  //  primary index field in database
            sql_pi=fieldname.trimmed();
        } else if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
                if (!sql_fields.isEmpty()) sql_fields+=", ";
                if (!sql_values.isEmpty()) sql_values+=", ";

                sql_fields+=fieldname.trimmed();

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_values+="''";
                else sql_values+=":"+fieldname.trimmed();
        }
    }

    if (sql_fields.isEmpty() || sql_values.isEmpty()) return "No input VALUES for "+sql;

    sql+=" ("+sql_fields+") VALUES ("+sql_values+");";
    SqlQuery.prepare(sql);

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if(!TableField_isPrimaryIndex(i) //  primary index field in database
            && DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            if ((value.type()!=QVariant::String) || (value.toString()!=""))
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);
        }
    }

    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    SqlQuery.prepare("SELECT last_insert_rowid() AS "+sql_pi);
    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQuery);
    return "";
}


QString
DrmBlockDBSQLite::exeUPDATE(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));
    QSqlQuery SqlQueryReturning(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));

    if (!loadTableFields()) return "Can't load '" +Table.trimmed()+ "' table info";

    sql="UPDATE "+Table.trimmed();

    QString sql_set="";
    QString sql_where="";
    QString sql_returning="";

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(TableField_isPrimaryIndex(i)) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+=fieldname.trimmed()+"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+fieldname.trimmed();

                if (!sql_returning.isEmpty()) sql_returning+=", ";
                sql_returning+=":"+fieldname.trimmed()+ " AS "+fieldname.trimmed();

            } else {
                if (!sql_set.isEmpty()) sql_set+=", ";

                sql_set+=fieldname+"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_set+="''";
                else  sql_set+=":"+fieldname.trimmed();
            }
        else {}

    }

    if (sql_set.isEmpty() || sql_where.isEmpty()) return "No input VALUES for "+sql;

    sql+=" SET "+sql_set+" WHERE "+sql_where;
    SqlQuery.prepare(sql);

    SqlQueryReturning.prepare("SELECT "+sql_returning);

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if(DrmSysDataSet_haveField(InPutDataSet, fieldname))
        {
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            if ((value.type()!=QVariant::String) || (value.toString()!=""))
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);

            if (TableField_isPrimaryIndex(i)){
                if ((value.type()!=QVariant::String) || (value.toString()!=""))
                    SqlQueryReturning.bindValue(":"+fieldname.trimmed(), value);
            }
        }
    }


    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + SqlQuery.lastQuery();

    if (!SqlQueryReturning.exec()) return SqlQueryReturning.lastError().text() + " in SQL: " + SqlQueryReturning.lastQuery();

    DataSet.setQuery(SqlQueryReturning);
    return "";
}

QString
DrmBlockDBSQLite::exeDELETE(DrmSysDataSet *InPutDataSet)
{
    QString sql;

    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));
    QSqlQuery SqlQueryReturning(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));

    if (!loadTableFields()) return "Can't load '" +Table.trimmed()+ "' table info";

    sql="DELETE FROM "+Table.trimmed();

    QString sql_where="";
    QString sql_returning="";

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if (DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if(TableField_isPrimaryIndex(i)) //  primary index field in database
            {
                if (!sql_where.isEmpty()) sql_where+=" AND ";
                sql_where+=fieldname.trimmed()+"=";

                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()==QVariant::String) && (value.toString()=="")) sql_where+="''";
                else  sql_where+=":"+fieldname.trimmed();
            }
    }

    if ( sql_where.isEmpty()) return "No input VALUES for WHERE in "+sql;

    sql+=" WHERE "+sql_where;
    SqlQuery.prepare(sql);

    for (int i=0; i<TableFields.rowCount(); ++i)
    {
        QString fieldname=TableFieldName(i);
        if(DrmSysDataSet_haveField(InPutDataSet, fieldname))
            if (TableField_isPrimaryIndex(i)){
                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                if ((value.type()!=QVariant::String) || (value.toString()!=""))
                    SqlQuery.bindValue(":"+fieldname.trimmed(), value);
        }
    }


    if (!SqlQuery.exec()) return SqlQuery.lastError().text() + " in SQL: " + sql;

    DataSet.setQuery(SqlQueryReturning);
    return "";
}

QString
DrmBlockDBSQLite::exeSQL(DrmSysDataSet *InPutDataSet)
{
    QSqlQuery SqlQuery(DrmSysSQLDataBases_getDataBase("QSQLITE",getCode()));

    if (SQL!="")
    {
        SqlQuery.prepare(SQL);

        for (int column=0; column < InPutDataSet->columnCount(); ++column)
        {
            QString fieldname = InPutDataSet->headerData(column, Qt::Horizontal).toString();
            QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
            SqlQuery.bindValue(":"+fieldname.trimmed(), value);

        }

        if (!SqlQuery.exec()){
            QString err = getCode()+" Error " + SqlQuery.lastError().text() + " in SQL: " + SqlQuery.lastQuery();
            for (int column=0; column < InPutDataSet->columnCount(); ++column)
            {
                QString fieldname = InPutDataSet->headerData(column, Qt::Horizontal).toString();
                QVariant value = DrmSysDataSet_getFieldValue(InPutDataSet, fieldname);
                err+="  "+fieldname+" = "+value.toString();

            }
            return err;
        }
    }
    else
    {
        for (int i=0; i<SQLs.count(); ++i)
        {
            SqlQuery.prepare(SQLs.at(i)->getSQL());

            SQLs.at(i)->InPutReplaceFieldsModel.setSourceModel(InPutDataSet);
            for (int column=0; column < SQLs.at(i)->InPutReplaceFieldsModel.columnCount(); ++column)
            {
                QString fieldname = SQLs.at(i)->InPutReplaceFieldsModel.headerData(column, Qt::Horizontal).toString();
                QVariant value = DrmSysDataSet_getFieldValue(&(SQLs.at(i)->InPutReplaceFieldsModel), fieldname);
                SqlQuery.bindValue(":"+fieldname.trimmed(), value);

            }

            if (!SqlQuery.exec())
                return "Error " + SqlQuery.lastError().text() + " in SQL: " + SQLs.at(i)->getSQL();
        }
    }

    DataSet.setQuery(SqlQuery);

    return "";
}
