#include <QCoreApplication>
#include <QDebug>
#include <QDeclarativeEngine>
#include <QDeclarativeComponent>
#include <QtGui/QApplication>

#include "ui/DrmUiApplication.h"
#include "ui/DrmUiMainWindow.h"
#include "ui/DrmUiFormList.h"

#include "ui/widget/DrmUiWidgetBoolSentence.h"
#include "ui/widget/DrmUiWidgetNumberSentence.h"
#include "ui/widget/DrmUiWidgetStringSentence.h"
#include "ui/widget/DrmUiWidgetDateSentence.h"
#include "ui/widget/DrmUiWidgetReferenceSentence.h"
#include "ui/widget/DrmUiWidgetParagraph.h"
#include "ui/widget/DrmUiWidgetParagraphList.h"

#include "sys/DrmSysObject.h"
#include "sys/DrmSysBlock.h"
#include "sys/DrmSysCascadeBlock.h"

#include "sys/DrmSysReplaceFieldsDataSet.h"

#include "blocks/DrmBlockForm.h"
#include "blocks/DrmBlockFormRegistry.h"
#include "blocks/DrmBlockFormCard.h"
#include "blocks/DrmBlockDBSQLite.h"
#include "blocks/DrmBlockDBPostgreSQL.h"




int main(int argc, char *argv[])
{
    QApplication App(argc, argv);

        DrmUiMainWindow MainWindow;
        MainWindow.setWindowIcon(QIcon("images/DaReManager.svg"));
        MainWindow.setWindowTitle (QObject::tr("DaReManager research project")) ;
        MainWindow.show();

            DrmUiFormList FormList(&MainWindow);

               DrmUiApplication* DrmApp=DrmUiApplication_get();
                DrmApp->setFormList(&FormList);


                    QDeclarativeEngine engine;
                    qmlRegisterType<DrmSysObject>("DaReManager", 0,1, "Object");
                    qmlRegisterType<DrmSysBlock>("DaReManager", 0,1, "Block");
                    qmlRegisterType<DrmSysCascadeBlock>("DaReManager", 0,1, "CascadeBlock");

                    qmlRegisterType<DrmSysReplaceFieldsDataSetField>("DaReManager", 0,1, "ReplaceField");


                    qmlRegisterType<DrmUiWidgetItem>("DaReManager", 0,1, "FormItem");
                    qmlRegisterType<DrmUiWidgetItemBool>("DaReManager", 0,1, "FormItemBool");
                    qmlRegisterType<DrmUiWidgetItemInteger>("DaReManager", 0,1, "FormItemInteger");
                    qmlRegisterType<DrmUiWidgetItemNumber>("DaReManager", 0,1, "FormItemNumber");
                    qmlRegisterType<DrmUiWidgetItemString>("DaReManager", 0,1, "FormItemString");
                    qmlRegisterType<DrmUiWidgetItemDate>("DaReManager", 0,1, "FormItemDate");
                    qmlRegisterType<DrmUiWidget>("DaReManager", 0,1, "FormWidjet");
                    qmlRegisterType<DrmUiWidgetParagraph>("DaReManager", 0,1, "FormParagraph");
                    qmlRegisterType<DrmUiWidgetParagraphList>("DaReManager", 0,1, "FormParagraphList");
                    qmlRegisterType<DrmUiWidgetBoolSentence>("DaReManager", 0,1, "FormBoolSentence");
                    qmlRegisterType<DrmUiWidgetNumberSentence>("DaReManager", 0,1, "FormNumberSentence");
                    qmlRegisterType<DrmUiWidgetStringSentence>("DaReManager", 0,1, "FormStringSentence");
                    qmlRegisterType<DrmUiWidgetDateSentence>("DaReManager", 0,1, "FormDateSentence");
                    qmlRegisterType<DrmUiWidgetReferenceSentence>("DaReManager", 0,1, "FormReferenceSentence");
                    qmlRegisterType<DrmUiWidgetRegistry>("DaReManager", 0,1, "FormRegistrySentence");
                    qmlRegisterType<DrmUiWidgetRegistryColumn>("DaReManager", 0,1, "FormRegistryColumn");

                    qmlRegisterType<DrmBlockForm>("DaReManager", 0,1, "Form");
                    qmlRegisterType<DrmBlockFormRegistry>("DaReManager", 0,1, "FormRegistry");
                    qmlRegisterType<DrmBlockFormCard>("DaReManager", 0,1, "FormCard");

                    qmlRegisterType<DrmBlockDBSQLiteSQL>("DaReManager", 0,1, "DBSQLiteSQL");
                    qmlRegisterType<DrmBlockDBSQLite>("DaReManager", 0,1, "DBSQLite");

                    qmlRegisterType<DrmBlockDBPostgreSQL>("DaReManager", 0,1, "DBPostgreSQL");
                    qmlRegisterType<DrmBlockDBPostgreSQLCONNECT>("DaReManager", 0,1, "DBPostgreSQLCONNECT");

                    QDeclarativeComponent ConfigComponent(&engine, QUrl::fromLocalFile("Config.qml"));
                    DrmSysBlock *ConfigBlock = qobject_cast<DrmSysBlock *>(ConfigComponent.create());

                    if (ConfigBlock) {
                        MainWindow.setWindowTitle (ConfigBlock->getFullName()) ;

                        ConfigBlock->start(new QStandardItemModel(ConfigBlock));

                        QDeclarativeComponent MainBlockComponent(&engine, QUrl::fromLocalFile("MainBlock.qml"));
                        DrmSysBlock *MainBlock = qobject_cast<DrmSysBlock *>(MainBlockComponent.create());

                        if (MainBlock) {
                            App.connect(MainBlock,SIGNAL(finished(DrmSysDataSet*)),SLOT(quit()));
                            App.connect(MainBlock,SIGNAL(terminated(QString)),SLOT(quit()));

                            MainBlock->start(new QStandardItemModel(MainBlock));
                        } else {
                            qWarning() << "No MainBlock.qml file load" << MainBlockComponent.errorString();;
                        }

                    } else {
                        qWarning() << "No Config.qml file load" << ConfigComponent.errorString();;
                    }



return App.exec();


}
