/********************   License  English   *************************************
 *    Library: Data Registry Manager
 *    File: DrmSysReplaceTieldsDataSet.cpp
 *    last change: Sergey Gershkovich, 2012/9/4
 *
 *
 *    Copyright (c) 2012, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ********************   License Russian, UTF-8  ********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmSysReplaceTieldsDataSet.cpp
 *
 *    Copyright (c) 2012, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */

#include "DrmSysReplaceFieldsDataSet.h"


//// DrmSysReplaceFieldsDataSetField //////////////////////////////////////////////////////

DrmSysReplaceFieldsDataSetField::DrmSysReplaceFieldsDataSetField(QObject *parent):
    DrmSysObject (parent)
{
    SourceCodePrivate="";
}

//// DrmReplaceFieldsDataSet //////////////////////////////////////////////////////

DrmSysReplaceFieldsDataSet::DrmSysReplaceFieldsDataSet(QObject* parent) :
    QSortFilterProxyModel(parent)
{
    FieldsOn=false;
}

int
DrmSysReplaceFieldsDataSet::columnCount(const QModelIndex &parent) const
{
    if (FieldsOn) return Fields.count();

    return QSortFilterProxyModel::columnCount(parent) ;
}

QModelIndex
DrmSysReplaceFieldsDataSet::mapFromSource(const QModelIndex& SourceIndex) const
{
    QModelIndex SIndex=QSortFilterProxyModel::mapToSource(SourceIndex);

    if (FieldsOn)
    {
        QString SourceField=sourceModel()->headerData(SIndex.column(), Qt::Horizontal).toString();
        for (int column=0; column< Fields.count(); ++column)
        {
            if (Fields.at(column)->getSourceCode() == SourceField)
            {
                return sourceModel()->index(SIndex.row(), column, QModelIndex());
            }
        }
        return QModelIndex();
    }

    return SIndex;
}

QModelIndex
DrmSysReplaceFieldsDataSet::mapToSource(const QModelIndex& ReplaceFieldsIndex) const
{
    QModelIndex PIndex=QSortFilterProxyModel::mapToSource(ReplaceFieldsIndex);

    if (FieldsOn)
    {
        if (0<=PIndex.column() && PIndex.column()<Fields.count())
        {
            QString SourceField=Fields.at(PIndex.column())->getSourceCode();
            for (int column=0; column< sourceModel()->columnCount(); ++column)
            {
                if (sourceModel()->headerData(column, Qt::Horizontal).toString() == SourceField)
                {
                    return sourceModel()->index(PIndex.row(), column, QModelIndex());
                }
            }
        }
        return QModelIndex();
    }
    return PIndex;
}

QVariant
DrmSysReplaceFieldsDataSet::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (FieldsOn && role==Qt::DisplayRole && orientation==Qt::Horizontal
            && 0<=section && section<Fields.count()) return Fields.at(section)->getCode();

    return QSortFilterProxyModel::headerData(section, orientation, role);
}

bool
DrmSysReplaceFieldsDataSet::filterAcceptsRow ( int source_row, const QModelIndex & source_parent ) const
{
    foreach (QString word, FilterWords)
        if (!word.isEmpty()){
            bool flag_word=false;

            for (int column=0; column<sourceModel()->columnCount(); ++column ){
                QVariant value=sourceModel()->data(sourceModel()->index(source_row, column));

                switch (value.type())
                {
                    case QVariant::String:
                        flag_word=flag_word||(value.toString().toLower().indexOf(word.toLower())>=0);
                        break;
                    default:
                        flag_word=flag_word||(value.toString().toLower()==word.toLower());
                }
            }
            if(!flag_word) return false;
        }

    return QSortFilterProxyModel::filterAcceptsRow (source_row, source_parent);
}




