/***************************   English   **************************************
 *    Library: Data Registry Manager
 *    File: DrmUiWidgetCard.h
 *    last change: Sergey Gershkovich, 2011/05/25
 *
 *
 *    Copyright (c) 2011, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ***************************   Russian, UTF-8  *********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmUiWidgetCard.h
 *
 *    Copyright (c) 2011, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */



#ifndef DRMUIWIDGETCARD_H
#define DRMUIWIDGETCARD_H

#include <QWidget>
#include <QPushButton>

#include "DrmUiWidget.h"
#include "DrmUiWidgetParagraphList.h"
#include "../../sys/DrmSysDataSet.h"
#include "../../sys/DrmSysBlock.h"


class DrmUiWidgetCard : public DrmUiWidget
{
    Q_OBJECT

public:

    DrmUiWidgetCard(QObject *parent = 0);

    void drawWidgets(QWidget *MainWidget);

    QDeclarativeListProperty <DrmUiWidget> getContent(){return Content.getContent();}
    QDeclarativeListProperty <DrmUiWidget> getAdditions(){return QDeclarativeListProperty<DrmUiWidget>(this, Additions);}
private:
    DrmUiWidgetParagraphList Content;
    QList< DrmUiWidget* > Additions;

public slots:
    virtual void setValues(DrmSysDataSet* DataSet);
    virtual void getValues(DrmSysDataSet* DataSet);


};





#endif // DRMUIWIDGETCARD_H
