/********************   License  English   *************************************
 *    Library: Data Registry Manager
 *    File: DrmUiWidgetDateSentence.cpp
 *    last change: Sergey Gershkovich, 2012/6/18
 *
 *
 *    Copyright (c) 2012, Sergey Gerskovich
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    All rights reserved.
 *
 *
 *    Redistribution and use in source and binary forms, with or without
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *         1. Redistributions of source code must retain the above copyright
 *            notice, this list of conditions and the following disclaimer.
 *         2. Redistributions in binary form must reproduce the above
 *            copyright notice, this list of conditions and the following
 *            disclaimer in the documentation and/or other materials provided
 *            with the distribution.
 *
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 *    OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 ********************   License Russian, UTF-8  ********************************
 *
 *    Библиотека: Управляющего реестром данных
 *    Файл: DrmUiWidgetDateSentence.cpp
 *
 *    Copyright (c) 2012, Сергей Гершкович
 *    DaReManager.sourceforge.net
 *    SergeyGershkovich@gmail.com
 *    Все права защищены.
 *
 *    Разрешается повторное распространение и использование как в виде
 *    исходного кода, так и в двоичной форме, с изменениями или без, при
 *    соблюдении следующих условий:
 *
 *        1. При повторном распространении исходного кода должно оставаться
 *           указанное выше уведомление об авторском праве, этот список условий
 *           и последующий отказ от гарантий.
 *        2. При повторном распространении двоичного кода должно сохраняться
 *           указанная выше информация об авторском праве, этот список условий
 *           и последующий отказ от гарантий в документации и/или в других
 *           материалах, поставляемых при распространении.
 *
 *    ЭТА ПРОГРАММА ПРЕДОСТАВЛЕНА БЕСПЛАТНО ВЛАДЕЛЬЦАМИ АВТОРСКИХ ПРАВ И/ИЛИ
 *    ДРУГИМИ СТОРОНАМИ "КАК ОНА ЕСТЬ" БЕЗ КАКОГО-ЛИБО ВИДА ГАРАНТИЙ,
 *    ВЫРАЖЕННЫХ ЯВНО ИЛИ ПОДРАЗУМЕВАЕМЫХ, ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ИМИ,
 *    ПОДРАЗУМЕВАЕМЫЕ ГАРАНТИИ КОММЕРЧЕСКОЙ ЦЕННОСТИ И ПРИГОДНОСТИ ДЛЯ
 *    КОНКРЕТНОЙ ЦЕЛИ. НИ В КОЕМ СЛУЧАЕ, ЕСЛИ НЕ ТРЕБУЕТСЯ СООТВЕТСТВУЮЩИМ
 *    ЗАКОНОМ, ИЛИ НЕ УСТАНОВЛЕНО В УСТНОЙ ФОРМЕ, НИ ОДИН ВЛАДЕЛЕЦ АВТОРСКИХ
 *    ПРАВ И НИ ОДНО ДРУГОЕ ЛИЦО, КОТОРОЕ МОЖЕТ ИЗМЕНЯТЬ И/ИЛИ ПОВТОРНО
 *    РАСПРОСТРАНЯТЬ ПРОГРАММУ, КАК БЫЛО СКАЗАНО ВЫШЕ, НЕ НЕСЁТ
 *    ОТВЕТСТВЕННОСТИ, ВКЛЮЧАЯ ЛЮБЫЕ ОБЩИЕ, СЛУЧАЙНЫЕ, СПЕЦИАЛЬНЫЕ ИЛИ
 *    ПОСЛЕДОВАВШИЕ УБЫТКИ, ВСЛЕДСТВИЕ ИСПОЛЬЗОВАНИЯ ИЛИ НЕВОЗМОЖНОСТИ
 *    ИСПОЛЬЗОВАНИЯ ПРОГРАММЫ (ВКЛЮЧАЯ, НО НЕ ОГРАНИЧИВАЯСЬ ПОТЕРЕЙ ДАННЫХ,
 *    ИЛИ ДАННЫМИ, СТАВШИМИ НЕПРАВИЛЬНЫМИ, ИЛИ ПОТЕРЯМИ ПРИНЕСЕННЫМИ ИЗ-ЗА ВАС
 *    ИЛИ ТРЕТЬИХ ЛИЦ, ИЛИ ОТКАЗОМ ПРОГРАММЫ РАБОТАТЬ СОВМЕСТНО С ДРУГИМИ
 *    ПРОГРАММАМИ), ДАЖЕ ЕСЛИ ТАКОЙ ВЛАДЕЛЕЦ ИЛИ ДРУГОЕ ЛИЦО БЫЛИ ИЗВЕЩЕНЫ О
 *    ВОЗМОЖНОСТИ ТАКИХ УБЫТКОВ.
 *
 */
#include <QBoxLayout>
#include <QLabel>
#include <QDateEdit>
#include <QCheckBox>

#include "DrmUiWidgetDateSentence.h"

DrmUiWidgetDateSentence::DrmUiWidgetDateSentence(QObject *parent)
    :DrmUiWidget(parent)
{
    connect(&ValuePrivate,SIGNAL(returnedValues(DrmSysDataSet*)),SIGNAL(returnedValues(DrmSysDataSet*)));
    connect(&ValuePrivate,SIGNAL(takedValues(DrmSysDataSet*)),SIGNAL(takedValues(DrmSysDataSet*)));

    ValuePrivate.setVisible(true);
    ValuePrivate.setField("");
    //ValuePrivate.setValue(QDate());

}

void
DrmUiWidgetDateSentence::drawWidgets(QWidget *parent)
{
    QGridLayout* Layout = new QGridLayout();
    Layout->setMargin(0);
    parent->setLayout(Layout);

    drawWidgets(Layout, 0);
}
int
DrmUiWidgetDateSentence::drawWidgets(QGridLayout* ParentLayout,  int row)
{
    QHBoxLayout* Layout = new QHBoxLayout();
        ParentLayout->addLayout(Layout,row,1,1,1,Qt::AlignLeft);

   QCheckBox* check=new QCheckBox(ParentLayout->parentWidget());
        Layout->addWidget(check);

        check->connect(&EnabledPrivate,SIGNAL(visibleChanged(bool)),SLOT(setVisible(bool)));
        check->setVisible(EnabledPrivate.getVisible());

        check->connect(&EnabledPrivate,SIGNAL(valueChanged(bool)),SLOT(setChecked(bool)));
        check->setChecked(EnabledPrivate.getValue());

        EnabledPrivate.connect(check,SIGNAL(toggled(bool)),SLOT(setValue(bool)));

   QLabel* label=new QLabel(ParentLayout->parentWidget());
        Layout->addWidget(label);

        label->connect(&CaptionPrivate,SIGNAL(visibleChanged(bool)),SLOT(setVisible(bool)));
        label->setVisible(CaptionPrivate.getVisible());

        label->connect(&CaptionPrivate,SIGNAL(valueChanged(QString)),SLOT(setText(QString)));
        label->setText(CaptionPrivate.getValue());

    QDateEdit* edit=new QDateEdit(ParentLayout->parentWidget());
        ParentLayout->addWidget(edit,row,2,Qt::AlignLeft);

        edit->connect(&ValuePrivate,SIGNAL(visibleChanged(bool)),SLOT(setVisible(bool)));
        edit->setVisible(ValuePrivate.getVisible());

        edit->connect(&ValuePrivate,SIGNAL(valueChanged(QDate)),SLOT(setDate(QDate)));
        edit->setDate(ValuePrivate.getValue());

        edit->connect(check,SIGNAL(toggled(bool)),SLOT(setEnabled(bool)));
        edit->setEnabled(EnabledPrivate.getValue());

        ValuePrivate.connect(edit,SIGNAL(dateChanged(QDate)),SLOT(setValue(QDate)));

    //Layout->addStretch();

    return 1;
}

void
DrmUiWidgetDateSentence::setValues(DrmSysDataSet* DataSet)
{
    if (!EnabledPrivate.getField().isEmpty())
        EnabledPrivate.setValue(DrmSysDataSet_getFieldValue(DataSet, EnabledPrivate.getField(), EnabledPrivate.getValue()).toBool());

    if (!CaptionPrivate.getField().isEmpty())
        CaptionPrivate.setValue(DrmSysDataSet_getFieldValue(DataSet, CaptionPrivate.getField(), CaptionPrivate.getValue()).toString());

    if (!ValuePrivate.getField().isEmpty())
        ValuePrivate.setValue(DrmSysDataSet_getFieldValue(DataSet, ValuePrivate.getField(), ValuePrivate.getValue()).toDate());
}

void
DrmUiWidgetDateSentence::getValues(DrmSysDataSet* DataSet)
{
    if (!ValuePrivate.getField().isEmpty())
        DrmSysDataSet_setFieldValue(DataSet, ValuePrivate.getField(), ValuePrivate.getValue());

    if (!EnabledPrivate.getField().isEmpty())
        DrmSysDataSet_setFieldValue(DataSet, EnabledPrivate.getField(), EnabledPrivate.getValue());

}
